#include "partition.h"
#include <bits/stdc++.h>
using namespace std;
#define ff first
#define ss second
#define pb push_back
//#define int long long
pair <int,int> a[2000005];
bool vis[2000005];
std::vector<int> solve(std::vector<int> A){
    int n=A.size();
    for(int i=1;i<=n;i++){
        a[i]=make_pair(A[i-1],i);
        vis[i]=0;
    }
    vector <int> vec,vec1;
    vector <pair <int,int> > b;
    sort(a+1,a+n+1);
    for(int i=2;i<=n;i++){
        if(a[i].ff==a[i-1].ff){
            vis[i]=1;
            vis[i-1]=1;
            vec.pb(a[i].ss);
            vec1.pb(a[i-1].ss);
            i++;
            continue;
        }
    }
    for(int i=1;i<=n;i++){
        if(!vis[i]){
            b.pb(a[i]);
            
        }
    }
    sort(b.begin(),b.end());
    // for(auto u:b){
    //     cout<<u.ff<<" "<<u.ss<<endl;
    // }
    for(int i=0;i<(b.size())/2 -1;i++){
        vec.pb(b[i].ss);
    }
    vec.pb(b.back().ss);
    for(int i=(b.size())/2-1;i<b.size()-1;i++){
        vec1.pb(b[i].ss);
    }
    for(auto u:vec1){
        vec.pb(u);
    }
    for(auto &u:vec){
        u--;
    }
    return vec;
}
// int main () {
//     ios_base::sync_with_stdio(false);
//     cin.tie(NULL);
//     int t;
//     cin >> t ;
//     for (int test=1; test<=t; test++) {
//         int n;
//         cin >> n ;
//         vector <int> a(n);
//         for (int i=0; i<n; i++) {
//             cin >> a[i] ;
//         }

//         for (auto ind : solve(a)) {
//             cout << ind << " ";
//         }
//         cout << endl ;
//     }
//     cout << endl ;
//     return 0;
// }
